# Share an agent test

Grant Viewer or Editor access to one existing member of the same Workspace. This dashboard-only operation does not create public links.

## Endpoint

`PUT /api/v1/workspaces/{workspace_id}/agent-tests/{test_id}/access`

## Authentication

| Class | Authentication | Minimum role | API key |
| --- | --- | --- | --- |
| dashboard-session-api | Dashboard session cookie; mutations also require X-CX-Request: 1. | member | Not allowed |

## Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `workspace_id` | path | `string` | Yes | — |
| `test_id` | path | `string` | Yes | — |

## Request body

### application/json request schema

| Field path | Type | Reference | Format | Nullable | Required | Enum | Description |
| --- | --- | --- | --- | --- | --- | --- | --- |
| `$` | `object` | AccessBody | — | No | Yes | — | — |
| `role` | `string` | — | — | No | Yes | "viewer", "editor" | — |
| `user_id` | `string` | — | — | No | Yes | — | — |

## Example

```bash
curl --request PUT 'https://operade.ai/api/v1/workspaces/ws_demo/agent-tests/test_demo/access' \
  --cookie 'cx_session=YOUR_SESSION_COOKIE' \
  --header 'X-CX-Request: 1' \
  --header 'Content-Type: application/json' \
  --data '{"user_id":"usr_demo","role":"viewer"}'
```

## Responses

| Status | Description | Content |
| --- | --- | --- |
| 4XX | Handled client error | application/json: `ErrorResponse` |
| 200 | Successful Response | application/json: `AccessGrant` |

### 4XX application/json response schema

| Field path | Type | Reference | Format | Nullable | Required | Enum | Description |
| --- | --- | --- | --- | --- | --- | --- | --- |
| `$` | `object` | ErrorResponse | — | No | Yes | — | — |
| `error` | `object` | ErrorItem | — | No | Yes | — | — |
| `error.code` | `string` | — | — | No | Yes | — | — |
| `error.details` | `object` | — | — | No | No | — | — |
| `error.message` | `string` | — | — | No | Yes | — | — |

### 200 application/json response schema

| Field path | Type | Reference | Format | Nullable | Required | Enum | Description |
| --- | --- | --- | --- | --- | --- | --- | --- |
| `$` | `object` | AccessGrant | — | No | Yes | — | — |
| `role` | `string` | — | — | No | Yes | "viewer", "editor" | — |
| `user_id` | `string` | — | — | No | Yes | — | — |

### Response example

```json
{
  "user_id": "string",
  "role": "viewer"
}
```

## Errors

Reviewed common and route-declared errors are summarized here; the list is not exhaustive. Start with the [distributed error index](/docs/reference/api/errors) to find each code's canonical domain page.

| Status | Code | Description |
| --- | --- | --- |
| 401 | `unauthenticated` | Authentication is missing, invalid, or revoked. |
| 403 | `forbidden` | The authenticated caller does not have access to this operation. |
| 404 | `not_found` | The requested workspace resource was not found. |
| 422 | `validation_failed` | The request did not pass field or business validation. |

## Related operations

- [Create an agent test](/docs/api-reference/agent-tests/create-agent-test) — `POST /api/v1/workspaces/{workspace_id}/agent-tests`
- [Delete an agent test](/docs/api-reference/agent-tests/delete-agent-test) — `DELETE /api/v1/workspaces/{workspace_id}/agent-tests/{test_id}`
- [Get an agent test](/docs/api-reference/agent-tests/get-agent-test) — `GET /api/v1/workspaces/{workspace_id}/agent-tests/{test_id}`
